package com.ozs.pm.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ozs.base.domain.BaseAgency;
import com.ozs.common.enums.*;
import com.ozs.common.utils.StringUtils;
import com.ozs.common.utils.bean.BeanUtils;
import com.ozs.plan.doman.ProvisionalPlan;
import com.ozs.pm.doman.*;
import com.ozs.pm.doman.vo.responseVo.*;
import com.ozs.pm.mapper.PmDemandHisMapper;
import com.ozs.pm.service.*;
import com.ozs.system.domain.SysFileInfo;
import com.ozs.system.domain.vo.responseVo.SysDeptResponseVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 采购需求表历史表(PmDemandHis)è¡¨æå¡å®ç°ç±»
 *
 * @author makejava
 * @since 2023-03-06 16:43:50
 */
@Service
public class PmDemandHisServiceImpl extends ServiceImpl<PmDemandHisMapper, PmDemandHis> implements PmDemandHisService {
    @Autowired
    private PmBidFailureHisService pmBidFailureHisService;
    @Autowired
    private PmBidOpeningHisService pmBidOpeningHisService;
    @Autowired
    private PmBidWinningHisService pmBidWinningHisService;
    @Autowired
    private PmBidWinningOpeningRefHisService pmBidWinningOpeningRefHisService;
    @Autowired
    private PmBookBuildingHisService pmBookBuildingHisService;
    @Autowired
    private PmCallQuestionHisService pmCallQuestionHisService;
    @Autowired
    private PmDemandExpertRefHisService pmDemandExpertRefHisService;
    @Autowired
    private PmDemandHisService pmDemandHisService;
    @Autowired
    private PmExpertFeedbackHisService pmExpertFeedbackHisService;
    @Autowired
    private PmProcurementDocumentsReviewHisService pmProcurementDocumentsReviewHisService;
    @Autowired
    private PmReleaseAnnouncementHisService pmReleaseAnnouncementHisService;

    /**
     * 流废标退回
     * @param demandId
     * @param updateBy
     * @return
     * @throws Exception
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean returnBidFailure(Long demandId,String updateBy) throws Exception {
//        PmDemand pmDemand = this.getById(demandId);
//        if(ObjectUtils.isEmpty(pmDemand)){
//            throw new Exception("参数错误");
//        }
//        //把相关表数据存入历史表，清空相关表数据
//        PmDemandHis pmDemandHis = new PmDemandHis();
//        BeanUtils.copyProperties(pmDemand,pmDemandHis);
//
//        LambdaQueryWrapper<PmDemandHis> pmDemandHisLambdaQueryWrapper = new LambdaQueryWrapper<>();
//        pmDemandHisLambdaQueryWrapper.eq(PmDemandHis::getDemandId,demandId)
//                .orderByDesc(PmDemandHis::getReturnOrderNumber).last(" limit 1");
//        PmDemandHis pmDemandHisDb= this.pmDemandHisService.getOne(pmDemandHisLambdaQueryWrapper);
//        if(pmDemandHisDb != null){
//            pmDemandHis.setReturnOrderNumber(pmDemandHisDb.getReturnOrderNumber() + 1);
//        } else {
//            pmDemandHis.setReturnOrderNumber(1);
//        }
//        if(this.pmDemandHisService.save(pmDemandHis)){
//            UpdateWrapper<PmDemand> pmDemandUpdateWrapper = new UpdateWrapper<>();
//            pmDemandUpdateWrapper.lambda()
//                    .set(PmDemand::getAgencyId,null)
//                    .set(PmDemand::getExtractAgencyTime,null)
//                    .set(PmDemand::getPurchaseTaskDocumentNumber,null)
//                    .set(PmDemand::getTaskReleaseTime,null)
//                    .set(PmDemand::getHasExpert,0)
//                    .set(PmDemand::getProjectStatus,PmProjectStatus.WASTE_BID_RETURN.getCode())
//                    .set(PmDemand::getUpdateBy,updateBy)
//                    .set(PmDemand::getUpdateTime,new Date())
//                    .eq(PmDemand::getDemandId,demandId);
//            this.update(pmDemandUpdateWrapper);
//        }

        return true;
    }

    /**
     * 查询采购需求
     *
     * @param demandId 采购需求主键
     * @return 采购需求
     */
    @Override
    public PmDemandResVo selectPmDemandHisByDemandId(Long demandId, String detailType,Integer returnOrderNumber) {
        return null;
    }
}
